#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <emmintrin.h>
#include <x86intrin.h>

uint8_t array[10*4096];

int main(int argc, const char **argv) {
 int junk=0;
 register uint64_t time1, time2;
 volatile uint8_t *addr;
 int i;

 if (argc != 2) {
 	printf("*** ERROR ***\n");
 	printf(" Se necesita 1 argumento al menos para continuar\n");
 	printf(" Ejemplo: %s 1\n", argv[0]);
 	return -1;
 } else {
	 printf("========== Test nº: %d ==========\n\n", (int) atoi(argv[1]));

	 // Inicializar el array
	 for(i=0; i<10; i++) array[i*4096]=1;

	 // FLUSH del array en la caché de la CPU
	 for(i=0; i<10; i++) _mm_clflush(&array[i*4096]);

	 // Acceder a algún item en el array
	 array[3*4096] = 100;
	 array[7*4096] = 200;

	 for(i=0; i<10; i++) {
		addr = &array[i*4096];
		time1 = __rdtscp(&junk);
		junk = *addr;
		time2 = __rdtscp(&junk) - time1;
		printf("Tiempo de acceso al elemento [%d*4096]: %d Ciclos de CPU\n", i, (int) time2);
	 }
	 return 0;
 }
}

